/*
 * Copyright 1995-1996, Michael A. Cooper
 * This software may be freely distributed provided that the Author is fully
 * credited, and the software is not sold for profit or used in any for-profit
 * product without the express written consent of the Author.
 */
/*
 * $Header: /src/common/cmd/spm/2.x/RCS/config-os.h,v 1.17 1996/03/02 00:40:06 mcooper Exp $
 */

/*
 * OS specific configuration information
 */
#ifndef __my_config_os_h__
#define __my_config_os_h__

#include "config-data.h"

#if	defined(sunos) && OSMVER == 4
#define PWLOOK_TYPE		PWLOOK_NONE	/* Use what's available */
#define HAVE_LOCAL				/* Have local /etc pwd files */
#define HAVE_NIS				/* Have NIS/YP */
#endif	/* sunos 4 */

#if	defined(sunos) && OSMVER == 5
#define PWLOOK_TYPE		PWLOOK_NSSWITCH	/* Use /etc/nsswitch.conf */
#ifndef HOSTNAME_TYPE
#define HOSTNAME_TYPE		HOSTNAME_UNAME	/* Use uname() */
#endif
#define HAVE_LOCAL				/* Have local /etc pwd files */
#define HAVE_NIS				/* Have NIS/YP */
#define HAVE_NISPLUS				/* Have NIS+ */
#define HAVE_SPWD				/* Have /etc/shadow */
#endif	/* sunos 5 */

#if	defined(irix)
#define PWLOOK_TYPE		PWLOOK_NONE	/* Use what's available */
#ifndef HOSTNAME_TYPE
#define HOSTNAME_TYPE		HOSTNAME_UNAME	/* Use uname() */
#endif
#define HAVE_LOCAL				/* Have local /etc pwd files */
#define HAVE_NIS				/* Have NIS/YP */
#define HAVE_SPWD				/* Have /etc/shadow */
#if	OSMVER == 6
#define HAVE_XDR_TIME_T				/* We have xdr_time_t() */
#endif	/* irix 6 */
#endif	/* irix */

#if	defined(aix)
#define PWLOOK_TYPE		PWLOOK_NONE	/* Use what's available */
#ifndef HOSTNAME_TYPE
#define HOSTNAME_TYPE		HOSTNAME_UNAME	/* Use uname() */
#endif
#define HAVE_USERPW				/* Have *userpw() functions */
#define HAVE_NIS				/* Have NIS/YP */
#define NEED_LOCAL				/* We need LOCAL*() */
#endif	/* aix */

#if	defined(hpux)
#define PWLOOK_TYPE		PWLOOK_NONE	/* Use what's available */
#ifndef HOSTNAME_TYPE
#define HOSTNAME_TYPE		HOSTNAME_UNAME	/* Use uname() */
#endif
#define HAVE_HPUXPW				/* Have HPUXPW*() functions */
#define HAVE_NIS				/* Have NIS/YP */
#define NEED_LOCAL				/* We need LOCAL*() */
#define SHADOW_PWDFILE		"/.secure/etc/passwd"
#define SHADOW_LOCKFILE		"/.secure/etc/ptmp"
#endif	/* hpux */

/*
 * More setup.
 */

#if	!defined(HOSTNAME_TYPE)
#define HOSTNAME_TYPE		HOSTNAME_GETHOSTNAME
#endif	/* HOSTNAME_TYPE */

#if	defined(HAVE_SPWD)
#include <shadow.h>
#ifndef SHADOW_PWDFILE
#define SHADOW_PWDFILE		SHADOW
#endif
#ifndef SHADOW_LOCKFILE
#define SHADOW_LOCKFILE		SHADTEMP
#endif
#endif	/* HAVE_SPWD */

/*
 * Path to files
 */
#if	!defined(_PATH_BSHELL)
#define _PATH_BSHELL		"/bin/sh"	/* Bourne shell */
#endif

#endif	/* __my_config__os_h__ */
