/*
 * Copyright 1995-1996, Michael A. Cooper
 * This software may be freely distributed provided that the Author is fully
 * credited, and the software is not sold for profit or used in any for-profit
 * product without the express written consent of the Author.
 */
#ifndef lint
static char RCSid[] = 
"$Header: /src/common/cmd/spm/2.x/RCS/local.c,v 1.9 1996/03/02 00:41:43 mcooper Exp $";
#endif	/* lint */

/*
 * Password Management System Facilities for "local"
 */

#include "defs.h"

#if	defined(HAVE_LOCAL) || defined(NEED_LOCAL)

/*
 * Get our local domain name
 */
char *
LOCALgetDomain()
{
    return(DOMAIN_LOCAL);
}

/*
 * Check to see if UserName appears in the "local"
 * password facility.
 */
int
LOCALcheck(UserName, Facility)
    char		       *UserName;
    Facility_t		       *Facility;
{
    FILE		       *FilePtr;
    struct passwd	       *Pwd;

    FilePtr = fopen(Facility->PwdFile, "r");
    if (!FilePtr) {
	Error("Cannot open %s for reading: %s.", Facility->PwdFile, SYSERR);
	return(-1);
    }

    while (Pwd = fgetpwent(FilePtr))
	if (EQ(UserName, Pwd->pw_name)) {
	    (void) fclose(FilePtr);
	    return(0);
	}

    (void) fclose(FilePtr);
    return(-1);
}

/*
 * Look up UserName in our local password file.
 * We don't use fgetpwent() for efficiency reasons.
 */
struct passwd *
LOCALgetpwnam(UserName, Facility)
    char		       *UserName;
    Facility_t		       *Facility;
{
    FILE		       *FilePtr;
    register struct passwd     *PwdPtr = NULL;
    static char			Buff[BUFSIZ];
    register char	       *cp;

    FilePtr = fopen(Facility->PwdFile, "r");
    if (!FilePtr)
	return(PwdPtr);

    while (fgets(Buff, sizeof(Buff), FilePtr)) {
	if (!PWDmatch(UserName, Buff))
	    continue;

	(void) fclose(FilePtr);
	if (cp = strchr(Buff, '\n'))
	    *cp = CNULL;
	return(PWDstrtopwd(Buff));
    }

    (void) fclose(FilePtr);

    return(PwdPtr);
}

/*
 * Get name of server for local host.
 */
char *
LOCALgetserver(Server)
    char		       *Server;
    /*ARGSUSED*/
{
    return(GetHostName());
}

#endif	/* HAVE_LOCAL || NEED_LOCAL */
