/* From AIX 3.2 */
#define _SUN
static char sccsid[] = "@(#)60	1.5  com/lib/c/s/fgetpwent.c, bos, bos320 6/16/90 01:02:11";
#ifndef _SUN
/*
 * COMPONENT_NAME: (LIBCS) Standard C Library System Security Functions 
 * 
 * FUNCTIONS: (none)
 *
 * ORIGINS: (none)
 *
 * This module left intentionally blank.
 */
#endif	/* !_SUN	*/
#ifdef _SUN
/*
 * COMPONENT_NAME: (LIBCS) Standard C Library System Security Functions 
 *
 * FUNCTIONS: fgetpwent 
 *
 * ORIGINS: 26, 24, 27 
 *
 * This module contains IBM CONFIDENTIAL code. -- (IBM
 * Confidential Restricted when combined with the aggregated
 * modules for this product)
 * 
 * (C) COPYRIGHT International Business Machines Corp. 1985, 1989 
 * All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * Copyright (c) 1983 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 * 
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 *  1.6 88/02/08 SMI
 */

#include <stdio.h>
#include <string.h>
#include <pwd.h>


static char EMPTY[] = "";
static struct passwd *interpret();


struct passwd *
fgetpwent(f)
	FILE *f;
{
	char line1[BUFSIZ+1];

	if(fgets(line1, BUFSIZ, f) == NULL)
		return(NULL);
	return (interpret(line1, strlen(line1)));
}

static char *
pwskip(p)
	register char *p;
{
	while(*p && *p != ':' && *p != '\n')
		++p;
	if (*p == '\n')
		*p = '\0';
	else if (*p != '\0')
		*p++ = '\0';
	return(p);
}

static struct passwd *
interpret(val, len)
	char *val;
{
	register char *p;
	char *end;
	long x;
	static struct passwd *pwp;
	static char *line;
	register int ypentry;

	if (line == NULL) {
		line = (char *)calloc(1,BUFSIZ+1);
		if (line == NULL)
			return (0);
	}
	if (pwp == NULL) {
		pwp = (struct passwd *)calloc(1, sizeof (*pwp));
		if (pwp == NULL)
			return (0);
	}
	(void) strncpy(line, val, len);
	p = line;
	line[len] = '\n';
	line[len+1] = 0;

	/*
 	 * Set "ypentry" if this entry references the Yellow Pages;
	 * if so, null UIDs and GIDs are allowed (because they will be
	 * filled in from the matching Yellow Pages entry).
	 */
	ypentry = (*p == '+');

	pwp->pw_name = p;
	p = pwskip(p);
	pwp->pw_passwd = p;
	p = pwskip(p);
	if (*p == ':' && !ypentry)
		/* check for non-null uid */
		return (NULL);
	x = strtol(p, &end, 10);
	p = end;
	if (*p++ != ':' && !ypentry)
		/* check for numeric value - must have stopped on the colon */
		return (NULL);
	pwp->pw_uid = x;
	if (*p == ':' && !ypentry)
		/* check for non-null gid */
		return (NULL);
	x = strtol(p, &end, 10);	
	p = end;
	if (*p++ != ':' && !ypentry)
		/* check for numeric value - must have stopped on the colon */
		return (NULL);
	pwp->pw_gid = x;
/*	pwp->pw_quota = 0;		*/
/*	pwp->pw_comment = EMPTY; 	*/
	pwp->pw_gecos = p;
	p = pwskip(p);
	pwp->pw_dir = p;
	p = pwskip(p);
	pwp->pw_shell = p;
	while(*p && *p != '\n') p++;
	*p = '\0';
	return (pwp);
}
#endif	/* _SUN	*/
