.\"
.\" $Header: /src/common/cmd/spm/2.x/RCS/spm.conf.man,v 1.12 1996/03/01 21:13:28 mcooper Exp $
.\" 
.TH spm.conf 5 "29 February 1996"
.ds ]W USC-UCS
.SH NAME
spm.conf \- Password Management System configuration file
.SH SYNOPSIS
.B GECOS
.I "Label : Example : MaxSize"
.br
.B Include
.I filename
.br
.B PDinfo
.I "Key : Description : Example : Flags"
.br
.B Set
.I variable
.B =
.I value
.SH DESCRIPTION
The
.B spm.conf
file is read by the
.B spm,
.B spmadm,
.B spmd,
and
.B spmtrans,
programs.
Lines beginning with ``#'' are ignored.
.SH KEYWORDS
The following is the list of valid keywords and their syntax:

.IP "\fBGECOS \fILabel : Example : MaxSize\fR"
Define a subfield of the 
.B pw_gecos
portion of a passwd entry.
Multiple 
.B GECOS
entries can be used to define multiple parts (in order) of the
.B pw_gecos
field.
This information is used by
.B spm
when a user changes their 
.B GECOS
information via
.B chfn
or
.B "spm \-chfn".
Each field is seperated by
``:'' (colon).
The fields have the following definetions:
.RS
.IP \fILabel\fR
The label used when prompting the user for input.
e.g. "Full Name", "Office Location", etc.
.IP \fIExample\fR
An example of what type of input is requested.
e.g. "John W. Smith", "SAL 125", etc.
.IP \fIMaxSize\fR
The maximum size (in bytes) of input to accept from the user.
.RE

.IP "\fBInclude \fIfilename\fR"
Read the SPM configuration file
.I filename
and parse like any other
.B spm.conf
file.

.IP "\fBPDinfo \fIKey : Description : Example : Flags\fR"
Specify Personal Data information items.
Each 
.B PDinfo
entry
describes information found in the Personal Database associated with
.I Key.
The 
.I Description
and
.I Example
fields are used when prompting the user for this PD item.
The
.I Flags
field is an optional comma seperated list of flags which affect the handling of
this PD item.
The following are the valid flag names:
.RS
.IP \fBNoEcho\fR
When prompting a user for input, do not echo the user's key strokes.
.IP \fBStripSep\fR
Strip the seperator characters (default is``/-'')
when comparing user input with
values from the PD database.
The list of seperator characters is controlled by the
.B StripSepChars
variable.
.RE

.IP "\fBSet \fIvariable\fB=\fIvalue\fR"
Set a variable named
.I variable
to have a value of
.I value.
.I variable
may be one of the following:
.RS
.IP \fBAgeDir\fR
The name of the Age database directory.
(Default is
.B /var/spm/age
)
.IP \fBAskTries\fR
The maximum number of times a user is asked for information.
(Default is
.B 5
)
.IP \fBGecosSep\fR
The character to use to seperate subfields of the passwd
.B pw_gecos
field.
(Default is ``,'' (comma)).
.IP \fBLocalPostCmd\fR
The command to run after updating a local facility database.
(Default varies)
.IP \fBLocalPwdFile\fR
The name of the local facility password file.
(Default is usually
.B /etc/passwd
)
.IP \fBLocalPwdLock\fR
The name of the local facility password lock file.
(Default is usually
.B /etc/ptmp
)
.IP \fBLocalShadowFile\fR
The name of the local facility password shadow file (on supported systems).
(Default is 
.B /etc/shadow
)
.IP \fBLockRetryInt\fR
The intervel (in seconds) to retry obtaining a lock on a piece of data.
(Default is 
.B 10
)
.IP \fBMaxPwdSize\fR
Specify the maximum size in bytes of the 
.B pw_passwd
field.
This is used for sanity checking.
(Default is 20).
.IP \fBMaxShellSize\fR
Specify the maximum size in bytes of the 
.B pw_shell
field.
This is used for sanity checking.
(Default is 100).
.IP \fBMaxPWHent\fR
The maximum number of old passwords that are kept.
(Default is 
.B 20
)
.IP \fBNISPostCmd\fR
The command to run after a successful update of any NIS data.
(Default is none).
.IP \fBNISPwdFile\fR
The name of the NIS password file.
(Default is
.B /var/yp/src/passwd
)
.IP \fBNISPwdLock\fR
The name of the NIS password lock file.
(Default is
.B /var/yp/ptmp
)
.IP \fBNISdir\fR
The name of the top level NIS directory where NIS data is stored.
(Default is
.B /var/yp
)
.IP \fBPDaccess\fR
Access list for personal data.
(See the
.B "ACCESS INFORMATION"
section)
(Default is none)
.IP \fBPDserver\fR
The hostname of the personal data server.
(Default is the name of the facility server).
.IP \fBSPMaccess\fR
Access list for general SPM queries
(See the
.B "ACCESS INFORMATION"
section)
(Default is none)
.IP \fBSPMserver\fR
The name of the SPM server to send queries to.
(Default varies according to the facility being used.)
.IP \fBStripSepChars\fR
The list of characters that are striped from strings when comparing
values in the PD database.
(Default is ``/-''.)
.IP \fBPdDir\fR
The name of the personal data database directory.
(Default is
.B /var/spm/pd
)
.IP \fBPwdHistDir\fR
The name of the password history database directory.
(Default is
.B /var/spm/pwh
)
.IP \fBTransDir\fR
The name of the directory where SPM transaction files are stored.
(Default is
.B /var/spm/transactions
)
.IP \fBTransFacList\fR
The comma seperated list of facilities to enable transaction processing on.
e.g. 
.B "local, nis"
(Default is
not to do transaction processing.)
.IP \fBVerifyList\fR
List of verification types to check.
(See the
.B "VERIFICATION" section)
(Default are all items defined by
.B PDinfo
keywords)
.IP \fBVerifyNum\fR
The number of verification items that the user must successfully
supply.
(See the
.B "VERIFICATION" section)
(Default is
.B 2).
.RE
.SH "ACCESS INFORMATION"
.\" Describe PDaccess and SPMaccess
.PP
The 
.B PDaccess
and
.B SPMaccess
variables control access to 
.B spmd.
The
variables have the form:
.sp
.br
.nf
.RS
\fItype\fR=\fIvalue1\fR,\fItype\fR=\fIvalue2\fR,...
.RE
.fi
.br
.sp
.I type
can be either
.B host
or
.B net.
If
.I type
is 
.B host
then 
.I value
should be the name of a host.
If
.I type
is
.B net
then
.I value
should be either the name of a network or the IP address of the network.
.PP
An example is:
.sp
.br
.nf
.RS
host=karls.usc.edu,net=engnet
.RE
.fi
.br
.sp
.SH "VERIFICATION"
.\" Describe VerifyList, VerifyNum, and proceedure
.PP
The
.B VerifyList
and
.B VerifyNum
variables control most of the verification proceedures in
.B spm.
If 
.B VerifyNum
is greater than 0, then
.B spm
will require the user to supply additional information 
when changing their password.
The
.B spm
program will query the
personal data server to see what, if any,
information is available for the user.
The user is then prompted to supply what information the personal data server
said was available.
If no information is available, then no additional information is
asked for from the user.
The
.B VerifyNum
variable controls the number of verify information types that must be
answered correctly for the verification to be successful.
.PP
The
.B VerifyList
variable specifies which types of verification information are required
and the order in which to prompt the user for such information.
The valid types are defined by the
.I Key 
field of each
.B PDinfo
entry.
Each item in
.B VerifyList
should be seperated by a comma.
.SH FILES
/var/local/conf/spm.conf
/usr/lsd/conf/spm.conf	\- SPM config files
.SH "SEE ALSO"
spm(1),
spmadm(8),
spmd(8),
spmtrans(8)
.SH AUTHOR
Michael A. Cooper, 
.br
University Computing Services, 
.br
University of Southern California.
.SH BUGS
