.\"
.\" $Header: /src/common/cmd/spm/2.x/RCS/spm.man,v 1.11 1995/07/28 22:53:14 mcooper Exp $
.\" 
.TH spm 1 "29 August 1994"
.ds ]W USC-UCS
.SH NAME
spm \- System for Password Management user interface
.SH SYNOPSIS
.B spm
[
.B -chpw|-chsh|-chfn
]
[
.B -facility
.I facname
]
[
.I username
]
.br
.sp
.B passwd
[
.I options
]
.br
.sp
.B chsh
[
.I options
]
[
.I newshell
]
.br
.sp
.B chfn
[
.I options
]
.SH DESCRIPTION
.B spm
changes a 
user's password, login shell, or full name (GECOS)
information.
If
.B spm
is run as
.B passwd
or with the
.B \-chpw
option, the user's password is changed.
If run as
.B chsh
or with the
.B \-chsh
option, the user's shell is changed.
A
.I newshell
value may be specified on the command line.
If run as
.B chfn
or with the
.B \-chfn
option, the user's full name (GECOS) is changed.
In all cases, the user must always specify the 
current password for
.I username
or the password for
.B root
(on the 
.B spmd
server host)
for verification purposes.
.PP
If the user's password is being changed, the user may be prompted
to supply additional information for verification purposes.
What additional information is asked for is based on the local
configuration of the SPM system and the information available for
.I username.
.PP
New passwords should be six to eight characters long, consisting
of both lower and upper case letters.  It's further recommended that
at least one non-alphanumeric character (i.e. 
.B !@$%^&*()-+
) be included.
.B spm
will reject passwords that fail to pass a series of basic
tests or previously used passwords.
.PP
If no 
.I username
is specified, then the username of the user running
.B spm
is used.
.PP
Normally 
.B spm
will determine what password facility (i.e
.B files, NIS, NISplus)
.I username
first appears in and will change the appropriate value in that
name service.
The
.B \-facility
option may be used to override this behavior.
.PP
On startup
.B spm
searches for configuration files to read.  The first file found
is used and the rest discarded.  The config list is:
.sp
.nf
.RS
\fB
/var/local/conf/spm.conf
/usr/lsd/conf/spm.conf
\fR
.RE
.fi
.sp
After parsing the configuration file
.B spm
will then prompt the user for the current password to
.I username.
.B spm
then connects to the
.B spmd
server responsible for the selected password facility.
In the case of local /etc files, the localhost is contacted.
For NIS and NIS+, the master server for the local domain is contacted.
The facility server is asked to verify the current user's password.
If verification information is enabled in the
.B spm.conf
file, then
the personal data server (by default the facility server)
is then contacted and queried to find out what information is available
for
.I username.
The user is then prompted to supply the information which is then sent
to the personal data server for verification.
The user is then prompted to supply the new information for what
is being changed (i.e. password, full name, or shell).
The new information is then sent to the facility server for updating.
The user is then told of the success or failure of the update.
.SH OPTIONS
.IP \fB\-chfn\fP
Change full name (GECOS) information.
.IP \fB\-chsh\fP
Change login shell.
.IP \fB\-chpw\fP
Change password.
.IP "\fB\-facility \fIfacname\fR"
Change information in password facility
.I facname.
.SH FILES
.sp
/etc/passwd	\- Local password file
.br
/etc/shadow	\- Local file containing passwords
.br
/var/local/conf/spm.conf
/usr/lsd/conf/spm.conf	\- SPM config files
.SH "SEE ALSO"
spm.conf(5),
spmadm(8),
spmd(8),
spmtrans(8)
.SH AUTHOR
Michael A. Cooper, 
.br
University Computing Services, 
.br
University of Southern California.
.SH DIAGNOSTICS
.SH BUGS
