.\"
.\" $Header: /src/common/cmd/spm/2.x/RCS/spmadm.man,v 1.4 1995/07/28 22:53:38 mcooper Exp $
.\" 
.TH spmadm 8 "29 August 1994"
.ds ]W USC-UCS
.SH NAME
spmadm \- System for Password Management administrative command
.SH SYNOPSIS
.B spmadm
[
.I options
]
.B \-type
.I datatype
.B \-delete
.I key
.br
.sp
.B spmadm
[
.I options
]
.B \-type
.I datatype
.B \-set
.I key=value
.br
.sp
.B spmadm
[
.I options
]
.B \-type
.I datatype
.B \-user
.I username
.B \-show
.br
.sp
.B spmadm
[
.I options
]
.B \-type
.I datatype
.B \-read
.br
.sp
.B spmadm
[
.I options
]
.B \-type
.I datatype
.B \-write
.br
.sp
.sp
.I options
are:
.sp
.br
[
.B \-agedir
.I dirname
]
[
.B \-debug
]
[
.B \-domain
.I name
]
[
.B \-file
.I filename
]
[
.B \-keys
]
[
.B \-pddir
.I dirname
]
[
.B \-pwdhistdir
.I dirname
]
.\" [
.\" .B \-nispwdfile
.\" .I filename
.\" ]
.\" [
.\" .B \-nispwdlock
.\" .I filename
.\" ]
.\" [
.\" .B \-localpwdfile
.\" .I filename
.\" ]
.\" [
.\" .B \-localpwdlock
.\" .I filename
.\" ]
[
.B \-type
.B age|pd|pwh
]
[
.B \-user
.I username
]
.SH DESCRIPTION
.B spmadm
performs administrative operations on the System for Password Management
(SPM) databases
on the local host.  
The program must have read and/or write access to the SPM
which usually means it must be run as ``root''.
.PP
The 
.B \-delete
.I key
argument will delete the data in the
.I datatype
database with a key
of
.I key.
.PP
The
.B \-set
.I key=value
argument
will add/modify
the data with key
.I key
in the
.I datatype
database to have a value of
.I value.
The
.I key=value
argument is specific to the database type.
See the
.B "OPTIONS"
section for details.
.PP
The
.B \-show
argument will display the information for
.I username
from the
.I datatype
database.
.PP
The 
.B \-read
and
.B \-write
arguments will read (write) the raw database named
.I datatype
from standard input (output) or from
.I filename
if
.I \-file
is specified.
Each output (input) line is in a format specific to
.I datatype.
The first field is usually used as the key to the database entry.
The
.B \-write
argument should only be used in emergencies.
The
.B \-set
argument should normally be used to add/modify database entries.
See the
.B OPTIONS
section below for more details.
.SH OPTIONS
.IP "\fB\-agedir \fIdirname\fR"
Use
.I dirname
as the name of the AGE database directory.
.IP "\fB\-debug\fR"
Enable debugging messages.
.IP "\fB\-delete \fIkey\fR"
Delete database entry with key
.I key.
.IP "\fB\-domain \fIdomname\fR"
Set the domain name to
.I domname.
The default is the local hosts' domainname.
.IP "\fB\-file \fIfilename\fR"
Specify name of file to read/write.
Default is standard input/output.
.IP "\fB\-keys\fR"
Show database key word field.
.IP "\fB\-pddir \fIdirname\fR"
Use
.I dirname
as the name of the Personal Data database directory.
.IP "\fB\-pwdhistdir \fIdirname\fR"
Use
.I dirname
as the name of the password history database directory.
.IP "\fB\-read\fR"
Read and display all raw database entries.
.IP "\fB\-show\fR"
Show database entry.
.IP "\fB\-set \fIkey\fR=\fIvalue\fR"
Set database entry with key
.I key
to have a value of
.I value.
If a database entry with 
.I key
does not exist, a new entry is created.
If an entry already exists, then it is updated.
The
.I key
and
.I value
are database specific.
.IP
The format of
.I key
and
.I value
for the
.B pwh
database is:
.nf
.sp
.I "\tuser=user:pw1:pw2:pw3:..."
.sp
.fi
Each 
.I pw
field should be an encrypted password string.
.IP
The following applies to the
.B pd
database:
.RS
.IP \fBSSN=\fINNNNNNNNN\fR
Social Security Number is set to
.I NNNNNNNNN.
.IP \fBDOB=\fIMM-DD-YY\fR
Date Of Birth.  Format is Month-DayOfMonth-Year in numeric
values.  (e.g. 
.B 4-28-94
)
.IP \fBMomName=\fIName\fR
Set Mother's Maiden name to
.I Name.
.IP \fBHomeZIP=\fIcode\fR
Set Home ZIP code to
.I code.  (e.g.
.B 90210
)
.RE
.IP
The following applies to the
.B age
database:
.RS
.IP \fBMinChg=\fIdays\fR
Set the minimum number of days allowed between
changing passwords to be
.I days.
.IP \fBMaxValid=\fIdays\fR
Set the maximum number of days a password is valid
for to 
.I days.
.IP \fBWarnTime=\fIdays\fR
Set the number of days of warning a user is given before
their password expires to be
.I days.
.IP \fBInActive=\fIdays\fR
Set the number of days an account may be unused before
being disabled to be
.I days.
.IP \fBExpireDate=\fIdate\fR
Set the absolute date that the user's password expires to
be 
.I date.
The
.I date
is of form
\fBMM-DD-YY \fR[\fB HH:MM\fR[\fB:SS\fR] ]
.RE
.IP "\fB\-type \fIdatatype\fR"
Use database named
.I datatype.
.IP "\fB\-user \fIusername\fR"
Specify username named
.I username.
.IP "\fB\-write\fR"
Write raw data to a database.
.SH FILES
.sp
/var/local/conf/spm.conf
/usr/lsd/conf/spm.conf	\- SPM config files
.SH "SEE ALSO"
spm(1),
spm.conf(5),
spmd(8)
.SH AUTHOR
Michael A. Cooper, 
.br
University Computing Services, 
.br
University of Southern California.
.SH DIAGNOSTICS
.SH BUGS
