.\"
.\" $Header: /src/common/cmd/spm/2.x/RCS/spmd.man,v 1.11 1995/07/28 22:54:20 mcooper Exp $
.\" 
.TH spmd 8 "29 August 1994"
.ds ]W USC-UCS
.SH NAME
spmd \- System for Password Management server daemon
.SH SYNOPSIS
.B spmd
[
.B \-|+bg
]
[
.B \-agedir
.I dirname
]
[
.B \-debug
]
[
.B \-localpostcmd
.I command
]
[
.B \-localpwdfile
.I filename
]
[
.B \-localpwdlock
.I filename
]
[
.B \-nispostcmd
.I command
]
[
.B \-nispwdfile
.I filename
]
[
.B \-nispwdlock
.I filename
]
[
.B \-pddir
.I dirname
]
[
.B \-pwdhistdir
.I dirname
]
[
.B \-transdir
.I dirname
]
[
.B \-transfaclist
.I facility1,facility2,...
]
.SH DESCRIPTION
.B spmd
is the server for the System for Password Mangement.
It performs actions based on queries from the
.B spm
command.
These actions include checking a user's current password, listing
what verification information is available for a user,
checking verification information for a user,
and
changing a user's password, full name (GECOS), and login shell.
.PP
On startup
.B spmd
searches for configuration files to read.  The first file found
is used and the rest discarded.  The config list is:
.sp
.nf
.RS
\fB
/var/local/conf/spm.conf
/usr/lsd/conf/spm.conf
\fR
.RE
.fi
.sp
(See the
.B spm.conf(5)
manual for the syntax of
.B spm.conf
files.)
After parsing the configuration file
any arguments supplied on the command line are parsed which will override
what was specified in the
.B spm.conf
file.
.PP
When a client sends a query to check a user's password or update
their password, full name, or login shell,
the query includes
what password facility to use.
This is normally /etc files, YP/NIS, or NIS+.
.B spmd
will then perform the requested operation on the appropriate files
for that password facility.
The databases for age, personal data, and password history
are all 
.B ndbm(3)
databases named
.B /var/spm/age/\fIdomain\fR,
.B /var/spm/pd/\fIdomain\fR,
and
.B /var/spm/pwh/\fIdomain\fR
respectively.
The
.I domain
name is specified by the client sending the query and is
usually the client's NIS or NIS+ domainname or 
.B local
if no domainname is configured on the client.
.PP
If transaction processing is enabled (see
.B spm.conf(5) 
) 
for the facility specified in a
request, then any request to change a user's password, full name (GECOS), 
or shell
is logged to a transaction file for later processing.
Transaction files are placed in 
.B /var/spm/transactions.
See
.B spmtrans(8)
for more information.
.SH OPTIONS
.IP "\fB\-agedir \fIdirname\fR"
Use
.I dirname
as the name of the AGE database directory.
.IP \fB\-bg|+bg\fR
Disable (\fB\-bg\fR) or enable (\fB+bg\fR) running certain tasks such as
post commands (that
are normally run after updating things like
YP/NIS databases) in the background.
The default is to background if
.B \-debug
is not specified.
.IP "\fB\-debug\fR"
Enable debugging messages.
.IP "\fB\-localpostcmd \fIcommand\fR"
Run the command
.I command
after every update to the 
.B local
password facility.
.IP "\fB\-localpwdfile \fIfilename\fR"
Use
.I filename
as the password file for the
.B local
password facility.
.IP "\fB\-localpwdlock \fIfilename\fR"
Use
.I filename
as the lock file for the
.B local
password facility.
.IP "\fB\-nispostcmd \fIcommand\fR"
Run the command
.I command
after every update to the 
.B NIS
password facility.
.IP "\fB\-nispwdfile \fIfilename\fR"
Use
.I filename
as the password file for the
.B NIS
password facility.
.IP "\fB\-nispwdlock \fIfilename\fR"
Use
.I filename
as the lock file for the
.B NIS
password facility.
.IP "\fB\-pddir \fIdirname\fR"
Use
.I dirname
as the name of the Personal Data database directory.
.IP "\fB\-pwdhistdir \fIdirname\fR"
Use
.I dirname
as the name of the password history database directory.
.IP "\fB\-transdir \fIdirname\fR"
Use
.I dirname
as the name of the directory to use for transactions.
.IP "\fB\-transfaclist \fIfacility1,facility2,...\fR"
Enable
transaction processing on
.I facility1,facility2,...
.SH FILES
.sp
/etc/spmd.pid	\- PID file
.sp
/var/spm/age	\- Directory of age data
.br
/var/spm/pd	\- Directory of personal data data
.br
/var/spm/pwh	\- Directory of password history data
.br
/var/spm/transactions	\- Transaction directory
.br
/var/local/conf/spm.conf
/usr/lsd/conf/spm.conf	\- SPM config files
.SH "SEE ALSO"
spm(1),
ndbm(3),
spm.conf(5),
spmadm(8),
spmtrans(8)
.SH AUTHOR
Michael A. Cooper, 
.br
University Computing Services, 
.br
University of Southern California.
.SH DIAGNOSTICS
.SH BUGS
